package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataIMapper;
import com.pqs9900.pojo.HisData.DataHarmrateI;
import com.pqs9900.pojo.HisData.DataI;
import com.pqs9900.service.HisData.DataIService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 电流相关
 * @Date  2018/12/17 10:54
 **/
@Service
public class DataIServiceImpl implements DataIService {

    private static final Logger logger= LoggerFactory.getLogger(DataIServiceImpl.class);
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataIMapper dataIMapper;
    @Override
    public int saveDataI(DataI dataI) {
        return dataIMapper.insert(dataI);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataI(List<DataI> list) {
        return dataIMapper.insertDataI(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataI 电流相关数据
     */
    @Override
    public Future insertDataIExecutor(List<DataI> listDataI) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataI.size() / (double) inum);
                    List<DataI> tmpListDataI = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataI.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataI.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataI.addAll(listDataI.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataIMapper.insertDataI(tmpListDataI);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("电流相关导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
